import unittest
from tree import inorder, preorder, postorder

class TestDeque(unittest.TestCase):

	def test_preorder_basic(self):
		"""test preorder on exercise 5"""
		tree = {'a':('b',None), 'b':('c', 'd'), 'c': (None, None),
				'd': ('e', 'f'), 'e':(None,None), 'f':(None, None)}

		self.assertEqual(preorder(tree, 'a'), ['a','b','c','d','e','f'])
		
	def test_inorder_basic(self):
		"""test inorder on exercise 5"""
		tree = {'a':('b',None), 'b':('c', 'd'), 'c': (None, None),
				'd': ('e', 'f'), 'e':(None,None), 'f':(None, None)}

		self.assertEqual(inorder(tree, 'a'), ['c','b','e','d','f','a'])

	def test_postorder_basic(self):
		"""test postorder on exercise 5"""
		tree = {'a':('b',None), 'b':('c', 'd'), 'c': (None, None),
				'd': ('e', 'f'), 'e':(None,None), 'f':(None, None)}

		self.assertEqual(postorder(tree, 'a'), ['c','e','f','d','b','a'])


if __name__ == '__main__':
    unittest.main()

